﻿<template>
    <div class="content-grid content-grid--subpage">
        <Breadcrumbs :title="t(`routes.admin.children.members.edit.name`)" />
        <BackLinkTitle :title="t(`routes.admin.children.members.edit.name`)" />
        <Card>
            <MemberForm :member="member" @formSubmit="handleSubmit" />
        </Card>
    </div>
</template>

<script lang="ts" setup>
    import Breadcrumbs from "@/components/layout/Breadcrumbs.vue";
    import BackLinkTitle from "@/components/layout/BackLinkTitle.vue";
    import MemberForm from "@/components/members/MemberForm.vue"
    import Card from "@/components/layout/Card.vue";
    import {useI18n} from "vue3-i18n";
    import {Member} from "@/types/entities";
    import {notifyError, notifySuccess} from "@/notify";
    import {useMemberService} from "@/inversify.config";
    import {useRouter, useRoute} from "vue-router";
    import { ref } from "vue";
    import { IUpdateMemberRequest } from "@/types/requests/updateMemberRequest";

    const { t } = useI18n()
    const router = useRouter();
    const route = useRoute();
    const memberService = useMemberService();

    const memberId = route.params.id.toString();
    const member = ref<Member>(await memberService.getMemberWithId(memberId));

    async function handleSubmit(member: Member) {
        let succeededOrNotResponse = await memberService.updateMember(member as IUpdateMemberRequest)
        if (succeededOrNotResponse && succeededOrNotResponse.succeeded) {
            notifySuccess(t('validation.member.edit.success'))
            setTimeout(() => {
                router.back();
            }, 1500);
        } else {
            let errorMessages = succeededOrNotResponse.getErrorMessages('validation.member.edit');
            if (errorMessages.length == 0)
                notifyError(t('validation.member.edit.errorOccured'))
            else
                notifyError(errorMessages[0])
        }
    }
</script>